<?php
/**
 * Created by PhpStorm.
 * User: chouchou
 * Date: 2020-6-21
 * Time: 18:52
 */

namespace app\api\controller\v2\common;
use app\em\controller\Account;
use app\em\controller\Invoice;
use app\em\controller\WriteOff;
use app\em\model\EmInvoice;
use app\em\model\EmPayment;
use app\em\model\EmPaymentFk;
use app\em\model\EmPaymentInvoice;
use think\facade\Log;

class Payment
{
    public function index()
    {
        $data = request()->get();
        $res = $this->checkKey($data['key']);


        if ($res !== true) return json([
            'code' => 201,
            'message' => $res,
            'data' => ''
        ]);
        if ($data['action'] == 1) {
            Log::record(date('Y-m-d H:i:s').' OA单号:'.$data['numb'].' 接口操作:单据状态更新');
            return $this->update($data['numb'],$data['status'],$data['mes']);
        } else {
            Log::record(date('Y-m-d H:i:s').' OA单号:'.$data['numb'].' 接口操作:单据作废');
            return $this->dropNumb($data['numb'],$data['status']);
        }
    }

    //更新payment状态
    private function update($numb,$status,$mes='')
    {
        $paymentFk = (new EmPaymentFk())->get(['oafk_numb' => $numb]);
        $payment = (new EmPayment())->get(['payment_id' => $paymentFk->payment_id]);

        //更新账户余额

        if($payment->account_id != ''){
            (new Account())->computerAmountFromPay($payment->account_id,$payment->amount);
        }

        $res = (new WriteOff())->writeOffFromPayment($payment->payment_id);

        $payment->status = $status;
        $payment->pay_date = time();
        $payment->save();

        Log::record(date('Y-m-d H:i:s').' OA单号:'.$numb . $res);
        return json([
            'code' => 201,
            'message' => $res,
            'data' => ''
        ]);
    }

    //作废单据
    private function dropNumb($numb,$status)
    {
        $paymentFk = (new EmPaymentFk())->get(['oafk_numb' => $numb,'status'=>1]);
        $payment = (new EmPayment())->get(['payment_id' => $paymentFk->payment_id]);
        $paymentFk->status = 0;
        $paymentFk->save();
        $payment->status = $status;
        $payment->save();

        //删除payment_invoice表
        $invoices = (new EmPaymentInvoice())->where('payment_id', '=', $paymentFk->payment_id)->delete();

        $message = ' 缴费单: '.$paymentFk->payment_id. '缴费单已作废';
        Log::record(date('Y-m-d H:i:s').$message);
        return json(
        [
            'code' => 201,
            'message' => $message,
            'data' => ''
        ]);

    }

    private function checkKey($key)
    {
        if (empty($key)) {
            return '秘钥不能为空';
        }

        $baseKey = substr(md5(config('oafk.oa_key') . date('Y-m-d')), 0, 12);
        if ($key != $baseKey) {

            return '秘钥错误';
        }
        return true;
    }

    public function setInvoiceStatus($statusCode, $value, $index = 0)
    {
        return substr_replace($statusCode, $value, $index, 1);
    }

    public function test(){
        $data = request()->get();

        if ($data['action'] == 1) {
            Log::record(date('Y-m-d H:i:s').' OA单号:'.$data['numb'].' 接口操作:单据状态更新');
            return $this->update($data['numb'],$data['status'],$data['mes']);
        } else {
            return $this->dropNumb($data['numb'],$data['status']);
        }
    }

    public function commonCheckKey($key){
        return $this->checkKey($key);
    }
}