<?php
/**
 * Created by PhpStorm.
 * User: chouchou
 * Date: 2020-6-21
 * Time: 18:52
 */

namespace app\api\controller\v2\common;

use think\Controller;
use think\Db;

class Project extends Controller
{
    public $jzdb;

    public function initialize()
    {
        $this->jzdb = Db::connect([
            'type' => config('jz.jztype'),
            'hostname' => config('jz.jzhostname'),
            'database' => config('jz.jzdatabase'),
            'username' => config('jz.jzusername'),
            'password' => config('jz.jzpassword'),
            'hostport' => config('jz.jzhostport'),
            'charset' => config('jz.jzcharset'),
        ]);
    }

    public function project_list()
    {
        $data = request()->get() ?: [];

        if(!array_key_exists('key',$data)){
            json([
                'code' => 201,
                'message' => 'request params not found!',
                'data' => ''
            ]);
        } else {
            $res = (new Payment())->commonCheckKey($data['key']);
        }
        if ($res !== true) return json([
            'code' => 201,
            'message' => $res,
            'data' => ''
        ]);
        $project_code = $data['project_code'];
        if (empty($project_code)) {
            return json([
                'code' => 202,
                'message' => 'Not valid parameter',
            ]);
        }


        $map[] = ['project_code', '=', $project_code];
        $datalist = $this->jzdb->table('jz_message')->field('project_code,jz_cur_dept')->where($map)->select();
        return json([
            'code' => 200,
            'message' => 'SUCCESS',
            'data' => $datalist,
        ]);
    }
}